Index: trunk/NEMO/LIM_SRC/limrst.F90
===================================================================
--- trunk/NEMO/LIM_SRC/limrst.F90	(revision 716)
+++ trunk/NEMO/LIM_SRC/limrst.F90	(revision 717)
@@ -17,6 +17,6 @@
    !!----------------------------------------------------------------------
    USE ice
-   USE dom_oce
-   USE ice_oce         ! ice variables
+   USE sbc_oce
+   USE sbc_ice
    USE daymod
 
@@ -28,6 +28,6 @@
 
    PUBLIC   lim_rst_opn     ! routine called by ??? module
-   PUBLIC   lim_rst_write   ! routine called by ??? module
-   PUBLIC   lim_rst_read    ! routine called by ??? module
+   PUBLIC   lim_rst_write   ! routine called by lim_step.F90
+   PUBLIC   lim_rst_read    ! routine called by lim_init.F90
 
    LOGICAL, PUBLIC ::   lrst_ice         !: logical to control the ice restart write 
@@ -56,6 +56,6 @@
       IF( kt == nit000 )   lrst_ice = .FALSE.
       
-      IF( kt == nitrst - 2*nfice + 1 .OR.  nitend - nit000 + 1 <= nfice ) THEN
-         ! beware if model runs less than nfice + 1 time step
+      IF( kt == nitrst - 2*nn_fsbc + 1 .OR.  nitend - nit000 + 1 <= nn_fsbc ) THEN
+         ! beware if model runs less than nn_fsbc + 1 time step
          ! beware of the format used to write kt (default is i8.8, that should be large enough)
          IF( nitrst > 1.0e9 ) THEN   
@@ -74,4 +74,5 @@
    END SUBROUTINE lim_rst_opn
 
+
    SUBROUTINE lim_rst_write( kt )
       !!----------------------------------------------------------------------
@@ -80,22 +81,21 @@
       !! ** purpose  :   output of sea-ice variable in a netcdf file
       !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt     ! number of iteration
-      !!
-      INTEGER ::   iter     ! kt + nfice -1
-      !!----------------------------------------------------------------------
-
-      iter = kt + nfice -1
+      INTEGER, INTENT(in) ::   kt   ! number of iteration
+      !
+      INTEGER ::   iter   ! kt + nn_fsbc -1
+      !!----------------------------------------------------------------------
+
+      iter = kt + nn_fsbc - 1
 
       IF( iter == nitrst ) THEN
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) 'lim_rst_write : write ice restart.output NetCDF file  kt =', kt
-         IF(lwp) WRITE(numout,*) '~~~~~~~'         
-      ENDIF
-
-      ! Write in numriw (if iter == nitrst)
+         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~'
+      ENDIF
+
+      ! Write in numriw (if iter  == nitrst)
       ! ------------------ 
       !                                                                     ! calendar control
-      CALL iom_rstput( iter, nitrst, numriw, 'nfice' , REAL( nfice, wp) )      ! time-step 
-      CALL iom_rstput( iter, nitrst, numriw, 'kt_ice', REAL( iter, wp) )      ! date
+      CALL iom_rstput( iter, nitrst, numriw, 'kt_ice', REAL( iter, wp) ) 
       
       CALL iom_rstput( iter, nitrst, numriw, 'hicif' , hicif (:,:)   )      ! prognostic variables 
@@ -109,8 +109,6 @@
       CALL iom_rstput( iter, nitrst, numriw, 'tbif2' , tbif  (:,:,2) )
       CALL iom_rstput( iter, nitrst, numriw, 'tbif3' , tbif  (:,:,3) )
-      CALL iom_rstput( iter, nitrst, numriw, 'u_ice' , u_ice (:,:)   )
-      CALL iom_rstput( iter, nitrst, numriw, 'v_ice' , v_ice (:,:)   )
-      CALL iom_rstput( iter, nitrst, numriw, 'gtaux' , gtaux (:,:)   )
-      CALL iom_rstput( iter, nitrst, numriw, 'gtauy' , gtauy (:,:)   )
+      CALL iom_rstput( iter, nitrst, numriw, 'ui_ice', ui_ice(:,:)   )
+      CALL iom_rstput( iter, nitrst, numriw, 'vi_ice', vi_ice(:,:)   )
       CALL iom_rstput( iter, nitrst, numriw, 'qstoif', qstoif(:,:)   )
       CALL iom_rstput( iter, nitrst, numriw, 'fsbbq' , fsbbq (:,:)   )
@@ -165,6 +163,5 @@
       !! ** purpose  :   read of sea-ice variable restart in a netcdf file
       !!----------------------------------------------------------------------
-      !
-      REAL(wp) ::   zfice, ziter
+      REAL(wp) ::   ziter
       !!----------------------------------------------------------------------
 
@@ -172,12 +169,11 @@
          WRITE(numout,*)
          WRITE(numout,*) 'lim_rst_read : read ice NetCDF restart file'
-         WRITE(numout,*) '~~~~~~~~'
+         WRITE(numout,*) '~~~~~~~~~~~~'
       ENDIF
 
       CALL iom_open ( 'restart_ice_in', numrir, kiolib = jprstlib )
 
-      CALL iom_get( numrir, 'nfice' , zfice )
-      CALL iom_get( numrir, 'kt_ice', ziter )    
-      IF(lwp) WRITE(numout,*) '   read ice restart file at time step    : ', ziter
+      CALL iom_get( numrir, 'kt_ice' , ziter )
+      IF(lwp) WRITE(numout,*) '   read ice restart file at time step    : ', INT( ziter )
       IF(lwp) WRITE(numout,*) '   in any case we force it to nit000 - 1 : ', nit000 - 1
 
@@ -186,8 +182,4 @@
       IF( ( nit000 - INT(ziter) ) /= 1 .AND. ABS( nrstdt ) == 1 )   &
          &     CALL ctl_stop( 'lim_rst_read ===>>>> : problem with nit000 in ice restart',  &
-         &                   '   verify the file or rerun with the value 0 for the',        &
-         &                   '   control of time parameter  nrstdt' )
-      IF( INT(zfice) /= nfice          .AND. ABS( nrstdt ) == 1 )   &
-         &     CALL ctl_stop( 'lim_rst_read ===>>>> : problem with nfice in ice restart',  &
          &                   '   verify the file or rerun with the value 0 for the',        &
          &                   '   control of time parameter  nrstdt' )
@@ -203,8 +195,6 @@
       CALL iom_get( numrir, jpdom_autoglo, 'tbif2' , tbif(:,:,2) )    
       CALL iom_get( numrir, jpdom_autoglo, 'tbif3' , tbif(:,:,3) )    
-      CALL iom_get( numrir, jpdom_autoglo, 'u_ice' , u_ice  )    
-      CALL iom_get( numrir, jpdom_autoglo, 'v_ice' , v_ice  )    
-      CALL iom_get( numrir, jpdom_autoglo, 'gtaux' , gtaux  )    
-      CALL iom_get( numrir, jpdom_autoglo, 'gtauy' , gtauy  )    
+      CALL iom_get( numrir, jpdom_autoglo, 'ui_ice', ui_ice )    
+      CALL iom_get( numrir, jpdom_autoglo, 'vi_ice', vi_ice )    
       CALL iom_get( numrir, jpdom_autoglo, 'qstoif', qstoif )    
       CALL iom_get( numrir, jpdom_autoglo, 'fsbbq' , fsbbq  )    
Index: trunk/NEMO/LIM_SRC/limsbc.F90
===================================================================
--- trunk/NEMO/LIM_SRC/limsbc.F90	(revision 716)
+++ trunk/NEMO/LIM_SRC/limsbc.F90	(revision 717)
@@ -61,8 +61,10 @@
       !!              - Update 
       !!     
-      !! ** Outputs : - fsolar  : solar heat flux at sea ice/ocean interface
-      !!              - fnsolar : non solar heat flux 
-      !!              - fsalt   : salt flux at sea ice/ocean interface
-      !!              - fmass   : freshwater flux at sea ice/ocean interface
+      !! ** Outputs : - qsr    : sea heat flux:     solar 
+      !!              - qns    : sea heat flux: non solar
+      !!              - emp    : freshwater budget: volume flux 
+      !!              - emps   : freshwater budget: concentration/dillution 
+      !!              - utau   : sea surface i-stress (ocean referential)
+      !!              - vtau   : sea surface j-stress (ocean referential)
       !!
       !! References : Goosse, H. et al. 1996, Bul. Soc. Roy. Sc. Liege, 65, 87-90.
@@ -183,12 +185,13 @@
             DO ji = 1, jpi
                ! ... change the cosinus angle sign in the south hemisphere
-               zsang  = SIGN(1.e0, gphif(ji-1,jj-1) ) * sangvg 
+!!              zsang  = SIGN(1.e0, gphif(ji-1,jj-1) ) * sangvg    ! do the full loop and avoid lbc_lnk
+               zsang  = SIGN(1.e0, gphif(ji,jj) ) * sangvg
                ! ... ice velocity relative to the ocean
-               zu_io  = u_ice(ji,jj) - u_oce(ji,jj)
-               zv_io  = v_ice(ji,jj) - v_oce(ji,jj)
-               zmod   = SQRT( zu_io * zu_io + zv_io * zv_io )
+               zu_io  = ui_ice(ji,jj) - ui_oce(ji,jj)
+               zv_io  = vi_ice(ji,jj) - vi_oce(ji,jj)
+               zmod   = rhoco * SQRT( zu_io * zu_io + zv_io * zv_io )
                ! ... ice stress over ocean with a ice-ocean rotation angle (at I-point)
-               ztio_u(ji,jj) = cw * zmod * ( cangvg * zu_io - zsang * zv_io )
-               ztio_v(ji,jj) = cw * zmod * ( cangvg * zv_io + zsang * zu_io )
+               ztio_u(ji,jj) = zmod * ( cangvg * zu_io - zsang * zv_io )
+               ztio_v(ji,jj) = zmod * ( cangvg * zv_io + zsang * zu_io )
                ! 
             END DO
@@ -196,5 +199,5 @@
 
          DO jj = 2, jpjm1
-            DO ji = 2, jpim1
+            DO ji = fs_2, fs_jpim1   ! vertor opt.
                ! ... ice-cover wheighted ice-ocean stress at U and V-points  (from I-point values)
                zutau  = 0.5 * ( ztio_u(ji+1,jj) + ztio_u(ji+1,jj+1) )
Index: trunk/NEMO/LIM_SRC/limthd.F90
===================================================================
--- trunk/NEMO/LIM_SRC/limthd.F90	(revision 716)
+++ trunk/NEMO/LIM_SRC/limthd.F90	(revision 717)
@@ -4,4 +4,8 @@
    !!              LIM thermo ice model : ice thermodynamic
    !!======================================================================
+   !! History :  1.0  !  00-01 (LIM)
+   !!            2.0  !  02-07 (C. Ethe, G. Madec) F90
+   !!            2.0  !  03-08 (C. Ethe)  add lim_thd_init
+   !!---------------------------------------------------------------------
 #if defined key_ice_lim
    !!----------------------------------------------------------------------
@@ -11,33 +15,30 @@
    !!   lim_thd_init : initialisation of sea-ice thermodynamic
    !!----------------------------------------------------------------------
-   !! * Modules used
+   USE phycst          ! physical constants
    USE dom_oce         ! ocean space and time domain variables
-   USE sbc_oce         ! surface boundary condition: ocean
+   USE lbclnk
+   USE in_out_manager  ! I/O manager
+   USE ice             ! LIM sea-ice variables
    USE ice_oce         ! sea-ice/ocean variables
+   USE sbc_oce         ! 
+   USE sbc_ice         ! 
    USE thd_ice         ! LIM thermodynamic sea-ice variables
    USE dom_ice         ! LIM sea-ice domain
-   USE ice             ! LIM sea-ice variables
    USE iceini
    USE limthd_zdf
    USE limthd_lac
    USE limtab
-   USE phycst          ! physical constants
-   USE in_out_manager  ! I/O manager
    USE prtctl          ! Print control
-   USE lbclnk
       
    IMPLICIT NONE
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC lim_thd       ! called by lim_step
-
-   !! * Module variables
-   REAL(wp)  ::            &  ! constant values
-      epsi20 = 1.e-20   ,  &
-      epsi16 = 1.e-16   ,  &
-      epsi04 = 1.e-04   ,  &
-      zzero  = 0.e0     ,  &
-      zone   = 1.e0
+   PUBLIC   lim_thd    ! called by lim_step
+
+   REAL(wp)  ::   epsi20 = 1.e-20   ,  &  ! constant values
+      &           epsi16 = 1.e-16   ,  &
+      &           epsi04 = 1.e-04   ,  &
+      &           zzero  = 0.e0     ,  &
+      &           zone   = 1.e0
 
    !! * Substitutions
@@ -47,5 +48,5 @@
    !!   LIM 2.0,  UCL-LOCEAN-IPSL (2005) 
    !! $Id$
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -68,13 +69,8 @@
       !!             - back to the geographic grid
       !!
-      !! ** References :
-      !!       H. Goosse et al. 1996, Bul. Soc. Roy. Sc. Liege, 65, 87-90
-      !!
-      !! History :
-      !!   1.0  !  00-01 (LIM)
-      !!   2.0  !  02-07 (C. Ethe, G. Madec) F90
+      !! References :   Goosse et al. 1996, Bul. Soc. Roy. Sc. Liege, 65, 87-90
       !!---------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt     ! number of iteration
-
+      !!
       INTEGER  ::   ji, jj,    &   ! dummy loop indices
          nbpb  ,               &   ! nb of icy pts for thermo. cal.
@@ -92,12 +88,10 @@
          zfontn             ,  &   ! heat flux from snow thickness
          zfntlat, zpareff          ! test. the val. of lead heat budget
-      REAL(wp), DIMENSION(jpi,jpj) :: &
-         zhicifp            ,  &   ! ice thickness for outputs
-         zqlbsbq                   ! link with lead energy budget qldif
-      REAL(wp), DIMENSION(jpi,jpj,jpk) :: &
-         zmsk                      ! working array
+      REAL(wp), DIMENSION(jpi,jpj) ::   zhicifp,   &  ! ice thickness for outputs
+         &                              zqlbsbq       ! link with lead energy budget qldif
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zmsk      ! working array
       !!-------------------------------------------------------------------
 
-      IF( kt == nit000  )   CALL lim_thd_init  ! Initialization (first time-step only)
+      IF( kt == nit000 )   CALL lim_thd_init  ! Initialization (first time-step only)
    
       !-------------------------------------------!
@@ -188,11 +182,12 @@
             !  temperature and turbulent mixing (McPhee, 1992)
             zfric_u        = MAX ( MIN( SQRT( ust2s(ji,jj) ) , zfric_umax ) , zfric_umin )  ! friction velocity
-            fdtcn(ji,jj)  = zindb * rau0 * rcp * 0.006  * zfric_u * ( sst_io(ji,jj) - tfu(ji,jj) ) 
+!!gm old    fdtcn(ji,jj)  = zindb * rau0 * rcp * 0.006  * zfric_u * ( sst_io(ji,jj) - tfu(ji,jj) ) 
+            fdtcn(ji,jj)  = zindb * rau0 * rcp * 0.006  * zfric_u * ( sst_m(ji,jj) - tfu(ji,jj) ) 
             qdtcn(ji,jj)  = zindb * fdtcn(ji,jj) * frld(ji,jj) * rdt_ice
                         
             !  partial computation of the lead energy budget (qldif)
             zfontn         = ( sprecip(ji,jj) / rhosn ) * xlsn  !   energy for melting
-            zfnsol         = qnsr_oce(ji,jj)  !  total non solar flux
-            qldif(ji,jj)   = tms(ji,jj) * ( qsr_oce(ji,jj) * ( 1.0 - thcm(ji,jj) )   &
+            zfnsol         = qns(ji,jj)                         !  total non solar flux over the ocean
+            qldif(ji,jj)   = tms(ji,jj) * ( qsr(ji,jj) * ( 1.0 - thcm(ji,jj) )   &
                &                               + zfnsol + fdtcn(ji,jj) - zfontn     &
                &                               + ( 1.0 - zindb ) * fsbbq(ji,jj) )   &
@@ -206,5 +201,6 @@
             
             !  energy needed to bring ocean surface layer until its freezing
-            qcmif  (ji,jj) =  rau0 * rcp * fse3t(ji,jj,1) * ( tfu(ji,jj) - sst_io(ji,jj) ) * ( 1 - zinda )
+!!gm old    qcmif  (ji,jj) =  rau0 * rcp * fse3t(ji,jj,1) * ( tfu(ji,jj) - sst_io(ji,jj) ) * ( 1 - zinda )
+            qcmif  (ji,jj) =  rau0 * rcp * fse3t(ji,jj,1) * ( tfu(ji,jj) - sst_m(ji,jj) ) * ( 1 - zinda )
             
             !  calculate oceanic heat flux.
@@ -258,5 +254,5 @@
          CALL tab_2d_1d( nbpb, fr1_i0_1d  (1:nbpb)     , fr1_i0     , jpi, jpj, npb(1:nbpb) )
          CALL tab_2d_1d( nbpb, fr2_i0_1d  (1:nbpb)     , fr2_i0     , jpi, jpj, npb(1:nbpb) )
-         CALL tab_2d_1d( nbpb, qnsr_ice_1d(1:nbpb)     , qnsr_ice   , jpi, jpj, npb(1:nbpb) )
+         CALL tab_2d_1d( nbpb, qns_ice_1d (1:nbpb)     , qns_ice    , jpi, jpj, npb(1:nbpb) )
 #if ! defined key_coupled
          CALL tab_2d_1d( nbpb, qla_ice_1d (1:nbpb)     , qla_ice    , jpi, jpj, npb(1:nbpb) )
@@ -394,19 +390,17 @@
       IF(ln_ctl) THEN
          CALL prt_ctl_info(' lim_thd  end  ')
-         CALL prt_ctl(tab2d_1=hicif , clinfo1=' lim_thd: hicif   : ', tab2d_2=hsnif , clinfo2=' hsnif  : ')
-         CALL prt_ctl(tab2d_1=frld  , clinfo1=' lim_thd: frld    : ', tab2d_2=hicifp, clinfo2=' hicifp : ')
-         CALL prt_ctl(tab2d_1=phicif, clinfo1=' lim_thd: phicif  : ', tab2d_2=pfrld , clinfo2=' pfrld  : ')
-         CALL prt_ctl(tab2d_1=sist  , clinfo1=' lim_thd: sist    : ')
-         CALL prt_ctl(tab2d_1=tbif(:,:,1), clinfo1=' lim_thd: tbif 1  : ')
-         CALL prt_ctl(tab2d_1=tbif(:,:,2), clinfo1=' lim_thd: tbif 2  : ')
-         CALL prt_ctl(tab2d_1=tbif(:,:,3), clinfo1=' lim_thd: tbif 3  : ')
-         CALL prt_ctl(tab2d_1=fdtcn , clinfo1=' lim_thd: fdtcn   : ', tab2d_2=qdtcn , clinfo2=' qdtcn  : ')
-         CALL prt_ctl(tab2d_1=qstoif, clinfo1=' lim_thd: qstoif  : ', tab2d_2=fsbbq , clinfo2=' fsbbq  : ')
-      ENDIF
-
-    END SUBROUTINE lim_thd
-
-
-    SUBROUTINE lim_thd_init
+         CALL prt_ctl(tab2d_1=hicif      , clinfo1=' hicif   : ', tab2d_2=hsnif      , clinfo2=' hsnif  : ')
+         CALL prt_ctl(tab2d_1=frld       , clinfo1=' frld    : ', tab2d_2=hicifp     , clinfo2=' hicifp : ')
+         CALL prt_ctl(tab2d_1=phicif     , clinfo1=' phicif  : ', tab2d_2=pfrld      , clinfo2=' pfrld  : ')
+         CALL prt_ctl(tab2d_1=sist       , clinfo1=' sist    : ', tab2d_2=tbif(:,:,1), clinfo2=' tbif 1 : ')
+         CALL prt_ctl(tab2d_1=tbif(:,:,2), clinfo1=' tbif 2  : ', tab2d_2=tbif(:,:,3), clinfo2=' tbif 3 : ')
+         CALL prt_ctl(tab2d_1=fdtcn      , clinfo1=' fdtcn   : ', tab2d_2=qdtcn      , clinfo2=' qdtcn  : ')
+         CALL prt_ctl(tab2d_1=qstoif     , clinfo1=' qstoif  : ', tab2d_2=fsbbq      , clinfo2=' fsbbq  : ')
+      ENDIF
+       !
+   END SUBROUTINE lim_thd
+
+
+   SUBROUTINE lim_thd_init
       !!-------------------------------------------------------------------
       !!                   ***  ROUTINE lim_thd_init *** 
@@ -419,7 +413,4 @@
       !!
       !! ** input   :   Namelist namicether
-      !!
-      !! history :
-      !!  8.5  ! 03-08 (C. Ethe) original code
       !!-------------------------------------------------------------------
       NAMELIST/namicethd/ hmelt , hiccrit, hicmin, hiclim, amax  ,        &
Index: trunk/NEMO/LIM_SRC/limthd_zdf.F90
===================================================================
--- trunk/NEMO/LIM_SRC/limthd_zdf.F90	(revision 716)
+++ trunk/NEMO/LIM_SRC/limthd_zdf.F90	(revision 717)
@@ -4,11 +4,14 @@
    !!                thermodynamic growth and decay of the ice 
    !!======================================================================
+   !! History :  1.0  !  01-04 (LIM) Original code
+   !!            2.0  !  02-08 (C. Ethe, G. Madec) F90
+   !!----------------------------------------------------------------------
 #if defined key_ice_lim
    !!----------------------------------------------------------------------
    !!   'key_ice_lim'                                     LIM sea-ice model
    !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
    !!   lim_thd_zdf  : vertical accr./abl. and lateral ablation of sea ice
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE par_oce          ! ocean parameters
    USE phycst           ! ???
@@ -22,18 +25,16 @@
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC lim_thd_zdf        ! called by lim_thd
-
-   !! * Module variables
-   REAL(wp)  ::           &  ! constant values
-      epsi20 = 1.e-20  ,  &
-      epsi13 = 1.e-13  ,  &
-      zzero  = 0.e0    ,  &
-      zone   = 1.e0
+   PUBLIC   lim_thd_zdf        ! called by lim_thd
+
+   REAL(wp) ::   epsi20 = 1.e-20  ,  &  ! constant values
+      &          epsi13 = 1.e-13  ,  &
+      &          zzero  = 0.e0    ,  &
+      &          zone   = 1.e0
    !!----------------------------------------------------------------------
    !!   LIM 2.0,  UCL-LOCEAN-IPSL (2005) 
    !! $Id$
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
-   !!----------------------------------------------------------------------
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
 CONTAINS
 
@@ -64,23 +65,12 @@
       !!              - Performs lateral ablation
       !!
-      !! References :
-      !!   Fichefet T. and M. Maqueda 1997, J. Geophys. Res., 102(C6), 12609-12646   
-      !!   Fichefet T. and M. Maqueda 1999, Clim. Dyn, 15(4), 251-268  
+      !! References : Fichefet T. and M. Maqueda 1997, J. Geophys. Res., 102(C6), 12609-12646   
+      !!              Fichefet T. and M. Maqueda 1999, Clim. Dyn, 15(4), 251-268  
+      !!------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kideb    ! Start point on which the  the computation is applied
+      INTEGER, INTENT(in) ::   kiut     ! End point on which the  the computation is applied
       !!
-      !! History :
-      !!   original    : 01-04 (LIM)
-      !!   addition    : 02-08 (C. Ethe, G. Madec)
-      !!------------------------------------------------------------------
-      !! * Arguments
-      INTEGER , INTENT (in) ::  &
-         kideb ,  &  ! Start point on which the  the computation is applied
-         kiut        ! End point on which the  the computation is applied
-
-      !! * Local variables
       INTEGER ::   ji       ! dummy loop indices
-
-      REAL(wp) , DIMENSION(jpij,2) ::  &
-         zqcmlt        ! energy due to surface( /1 ) and bottom melting( /2 )
-
+      REAL(wp), DIMENSION(jpij,2) ::   zqcmlt        ! energy due to surface( /1 ) and bottom melting( /2 )
       REAL(wp), DIMENSION(jpij) ::  &
          ztsmlt      &    ! snow/ice surface melting temperature
@@ -97,6 +87,5 @@
          , zts_old   &    ! previous surface temperature
          , zidsn , z1midsn , zidsnic ! tempory variables
-
-      REAL(wp), DIMENSION(jpij) :: &
+      REAL(wp), DIMENSION(jpij) ::   &
           zfnet       &  ! net heat flux at the top surface( incl. conductive heat flux)
           , zsprecip  &    ! snow accumulation
@@ -109,5 +98,4 @@
           , zfrld_1d    &    ! new sea/ice fraction
           , zep            ! internal temperature of the 2nd layer of the snow/ice system
-
        REAL(wp), DIMENSION(3) :: & 
           zplediag  &    ! principle diagonal, subdiag. and supdiag. of the 
@@ -115,5 +103,4 @@
           , zsupdiag  &    ! of the temperatures inside the snow-ice system
           , zsmbr          ! second member
-
        REAL(wp) :: & 
           zhsu     &     ! thickness of surface layer
@@ -130,5 +117,4 @@
           , zb2 , zd2 , zb3 , zd3 &
           , ztint          ! equivalent temperature at the snow-ice interface
-
        REAL(wp) :: & 
           zexp      &     ! exponential function of the ice thickness
@@ -148,5 +134,4 @@
           , zdtic        &  ! ice internal temp. increment
           , zqnes          ! conductive energy due to ice melting in the first ice layer
-
        REAL(wp) :: & 
           ztbot     &      ! temperature at the bottom surface
@@ -162,5 +147,4 @@
           , zc1, zpc1, zc2, zpc2, zp1, zp2 & ! tempory variables
           , ztb2, ztb3
-
        REAL(wp) :: & 
           zdrmh         &   ! change in snow/ice thick. after snow-ice formation
@@ -181,5 +165,4 @@
        !     Computation of energies due to surface and bottom melting 
        !-----------------------------------------------------------------------
-       
        
        DO ji = kideb , kiut
@@ -201,5 +184,4 @@
        END DO
 
-
        !-------------------------------------------
        !  2. Calculate some intermediate variables.  
@@ -265,5 +247,4 @@
        !     - qstbif_1d, total energy stored in brine pockets (updating)
        !-------------------------------------------------------------------
-
 
        DO ji = kideb , kiut
@@ -288,5 +269,4 @@
        END DO
 
-
        !--------------------------------------------------------------------------------
        !  4. Computation of the surface temperature : determined by considering the 
@@ -333,6 +313,6 @@
           !---computation of the energy balance function 
           zfts    = - z1mi0 (ji) * qsr_ice_1d(ji)   & ! net absorbed solar radiation
-             &      - qnsr_ice_1d(ji)                & ! total non solar radiation
-             &      - zfcsu (ji)                  ! conductive heat flux from the surface
+             &      - qns_ice_1d(ji)                & ! total non solar radiation
+             &      - zfcsu (ji)                      ! conductive heat flux from the surface
           !---computation of surface temperature increment  
           zdts    = -zfts / zdfts
@@ -360,5 +340,5 @@
           sist_1d(ji) = MIN( ztsmlt(ji) , sist_1d(ji) )
 #if ! defined key_coupled
-          qnsr_ice_1d(ji) = qnsr_ice_1d(ji) + dqns_ice_1d(ji) * ( sist_1d(ji) - zts_old(ji) )
+          qns_ice_1d(ji) = qns_ice_1d(ji) + dqns_ice_1d(ji) * ( sist_1d(ji) - zts_old(ji) )
           qla_ice_1d (ji) = qla_ice_1d (ji) + dqla_ice_1d(ji) * ( sist_1d(ji) - zts_old(ji) )
 #endif
@@ -366,11 +346,9 @@
        END DO
 
-     
-
        !     5.2. Calculate available heat for surface ablation. 
        !---------------------------------------------------------------------
 
        DO ji = kideb, kiut
-          zfnet(ji) = qnsr_ice_1d(ji) + z1mi0(ji) * qsr_ice_1d(ji) + zfcsu(ji)          
+          zfnet(ji) = qns_ice_1d(ji) + z1mi0(ji) * qsr_ice_1d(ji) + zfcsu(ji)          
           zfnet(ji) = MAX( zzero , zfnet(ji) )
           zfnet(ji) = zfnet(ji) * MAX( zzero , SIGN( zone , sist_1d(ji) - ztsmlt(ji) ) )
@@ -730,18 +708,11 @@
           dvnbq_1d(ji) = ( 1.0 - frld_1d(ji) ) * ( zhicnew - h_ice_1d(ji) )
           dmgwi_1d(ji) = dmgwi_1d(ji) + ( 1.0 -frld_1d(ji) ) * ( h_snow_1d(ji) - zhsnnew ) * rhosn
-          !  case of natural freshwater flux
-#if defined key_lim_fdd  
-          rdmicif_1d(ji) = rdmicif_1d(ji) + ( 1.0 - frld_1d(ji) )   * ( zhicnew - h_ice_1d(ji) )  * rhoic
+          !---  volume change of ice and snow (used for ocean-ice freshwater flux computation)
+          rdmicif_1d(ji) = rdmicif_1d(ji) + ( 1.0 - frld_1d(ji) )   * ( zhicnew - h_ice_1d (ji) ) * rhoic
           rdmsnif_1d(ji) = rdmsnif_1d(ji) + ( 1.0 - frld_1d(ji) )   * ( zhsnnew - h_snow_1d(ji) ) * rhosn
 
-#else
-          rdmicif_1d(ji) = rdmicif_1d(ji) + ( 1.0 - frld_1d(ji) ) * (  ( zhicnew - h_ice_1d(ji) ) * rhoic   &
-             &                                                    + ( zhsnnew - h_snow_1d(ji) ) * rhosn )
-#endif
-
           !---  Actualize new snow and ice thickness.
-
           h_snow_1d(ji)  = zhsnnew
-          h_ice_1d(ji)  = zhicnew
+          h_ice_1d (ji)  = zhicnew
 
        END DO
@@ -799,16 +770,18 @@
           qstbif_1d(ji) = zdrfrl2 * qstbif_1d(ji)
           frld_1d(ji)    = zfrld_1d(ji)
-
-       END DO
-       
+          !
+       END DO
+       ! 
     END SUBROUTINE lim_thd_zdf
+
 #else
-   !!======================================================================
-   !!                       ***  MODULE limthd_zdf   ***
-   !!                              no sea ice model  
-   !!======================================================================
+   !!----------------------------------------------------------------------
+   !!   Default Option                                     NO sea-ice model
+   !!----------------------------------------------------------------------
 CONTAINS
    SUBROUTINE lim_thd_zdf          ! Empty routine
    END SUBROUTINE lim_thd_zdf
 #endif
- END MODULE limthd_zdf
+
+   !!======================================================================
+END MODULE limthd_zdf
Index: trunk/NEMO/LIM_SRC/limtrp.F90
===================================================================
--- trunk/NEMO/LIM_SRC/limtrp.F90	(revision 716)
+++ trunk/NEMO/LIM_SRC/limtrp.F90	(revision 717)
@@ -112,6 +112,6 @@
          DO jj = 1, jpjm1
             DO ji = 1, jpim1
-               zui_u(ji,jj) = ( u_ice(ji+1,jj  ) + u_ice(ji+1,jj+1) ) / ( MAX( tmu(ji+1,jj  ) + tmu(ji+1,jj+1), zvbord ) )
-               zvi_v(ji,jj) = ( v_ice(ji  ,jj+1) + v_ice(ji+1,jj+1) ) / ( MAX( tmu(ji  ,jj+1) + tmu(ji+1,jj+1), zvbord ) )
+               zui_u(ji,jj) = ( ui_ice(ji+1,jj  ) + ui_ice(ji+1,jj+1) ) / ( MAX( tmu(ji+1,jj  ) + tmu(ji+1,jj+1), zvbord ) )
+               zvi_v(ji,jj) = ( vi_ice(ji  ,jj+1) + vi_ice(ji+1,jj+1) ) / ( MAX( tmu(ji  ,jj+1) + tmu(ji+1,jj+1), zvbord ) )
             END DO
          END DO
